unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uKonto; //Modellunit einbinden

type
  TGUI = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Btneinzahlen: TButton;
    Btnabheben: TButton;
    Btnueberweisen: TButton;
    EdBetrag: TEdit;
    EdEmpfaenger: TEdit;
    Label1: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    EdKNum: TEdit;
    EdKBesitzer: TEdit;
    EdKStand: TEdit;
    Btnzurueck: TButton;
    Btnvor: TButton;
    BtnAbfragen: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnAbfragenClick(Sender: TObject);
    procedure BtneinzahlenClick(Sender: TObject);
    procedure BtnabhebenClick(Sender: TObject);
    procedure BtnzurueckClick(Sender: TObject);
    procedure BtnvorClick(Sender: TObject);
    procedure BtnueberweisenClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
    aktKonto : TKonto;       //Konto, das bearbeitet wird
    aktNr : integer;         //Nr des aktuellen Kontos
    Konto : array of TKonto; //Liste aller Konten, Dynamischer Array
    procedure aktualisiereAnzeige; //Aktualisierung aller Views
  end;

var
  GUI: TGUI;

implementation

{$R *.DFM}

{**************************************************************}
{*             Fensterereignisse                              *}
{**************************************************************}
procedure TGUI.FormCreate(Sender: TObject);
begin
  setLength(Konto,3);   //Anzahl der Elemente des noch leeren Arrays setzen
  Konto[0] := TKonto.create(100,'Meyer');
  Konto[0].einzahlen(1000);
  Konto[1] := TKonto.create(101,'Schrder');
  Konto[1].einzahlen(10000);
  Konto[2] := TKonto.create(102,'Mller');
  Konto[2].einzahlen(5000);
  aktNr := 0;
  aktKonto := Konto[0];
end;

procedure TGUI.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to length(Konto)-1 do
    Konto[i].Free;
end;

{****************************************************************}
{*             Aktualisierung der Views                         *}
{*             durch Abfragen (Polling)                         *}
{****************************************************************}
procedure TGUI.aktualisiereAnzeige;
begin//Datenfluss:  Modell --> View
  EdKNum.Text := IntToStr(aktKonto.getKontoNummer);
  EdKBesitzer.Text := aktKonto.getBesitzer;
  EdKStand.Text := FloatToStr(aktKonto.getKontoStand);
end;

procedure TGUI.BtnAbfragenClick(Sender: TObject);
begin
  aktualisiereAnzeige;
end;

{****************************************************************}
{*             Controlerereignisse                              *}
{****************************************************************}
procedure TGUI.BtneinzahlenClick(Sender: TObject);
begin //Datenfluss: Controller --> Model
  if EdBetrag.Text <> '' then
    aktKonto.einzahlen(StrToInt(EdBetrag.Text));
end;

procedure TGUI.BtnabhebenClick(Sender: TObject);
begin //Datenfluss: Controller --> Model
  if EdBetrag.Text <> '' then
    aktKonto.abheben(StrToFloat(EdBetrag.Text));
end;

procedure TGUI.BtnueberweisenClick(Sender: TObject);
var
  EmpfNr : integer;
  Betrag : double;
begin //Datenfluss: Controler --> Model
  EmpfNr := StrToInt(EdEmpfaenger.Text)-100;
  Betrag := StrToFloat(EdBetrag.Text);
  if (EmpfNr > -1)and (EmpfNr < length(Konto))then
    aktKonto.ueberweisen(Betrag, Konto[EmpfNr]);
end;

{***********************************************************}
{* Auswahl der verschiedenen Konten                        *}
{***********************************************************}
procedure TGUI.BtnzurueckClick(Sender: TObject);
begin
  if aktNr > 0 then
    aktNr := aktNr - 1
  else
    aktNr := length(Konto)-1;
  aktKonto := konto[aktNr];
  aktualisiereAnzeige;
end;

procedure TGUI.BtnvorClick(Sender: TObject);
begin
  if aktNr < length(Konto)-1 then
    aktNr := aktNr + 1
  else
    aktNr := 0;
  aktKonto := konto[aktNr];
  aktualisiereAnzeige;
end;

end.
