UNIT uKonto;

interface

type
  TKonto = class
   private //Attribute
    KStand : double;
    Nummer : integer;
    Besitzer : string;
   public //Methoden
    constructor create (PNr: integer; PBesitzer: string);
    procedure abheben (PBetrag: double);
    procedure einzahlen (PBetrag: double);
    procedure ueberweisen (PBetrag: double; PEKonto : TKonto);
    function getBesitzer : string;
    function getKontoNummer : integer;
    function getKontoStand : double;
   end;

implementation

//+---------------------------------------------------------------------
//|         TKonto: Methodendefinition 
//+---------------------------------------------------------------------

//-------- create (public) ---------------------------------------------
constructor TKonto.create (PNr: integer; PBesitzer: string);
begin //Nummer und Besitzer werden gesetzt und knnen nicht mehr gendert werden!
  Nummer := PNr;
  Besitzer := PBesitzer;
end;

//-------- abheben (public) --------------------------------------------
procedure TKonto.abheben (PBetrag: double);
begin
  KStand := KStand - PBetrag;
end;

//-------- einzahlen (public) ------------------------------------------
procedure TKonto.einzahlen (PBetrag: double);
begin
  KStand := KStand + PBetrag;
end;

//-------- ueberweisen (public) ----------------------------------------
procedure TKonto.ueberweisen (PBetrag: double; PEKonto: TKonto);
begin
  abheben(PBetrag);
  PEKonto.einzahlen(PBetrag);
end;

//-------- getBesitzer (public) ----------------------------------------
function TKonto.getBesitzer : string;
begin
  result  := Besitzer
end;

//-------- getKontoNummer (public) -------------------------------------
function TKonto.getKontoNummer : integer;
begin
  result  := Nummer
end;

//-------- getKontoStand (public) --------------------------------------
function TKonto.getKontoStand : double;
begin
  result := KStand
end;

end.
